<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : <i class="icon-shield" style="color:#0186d1"></i> Gadget</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header"><i class="icon-shield" style="color:#0186d1"></i> Gadget</h1>
              



<section>
    
<header>
    <!--h2>
    Gadget
    </h2-->
    
</header>  

<article>
    <div class="container-overview hero-unit">
    

            
        <ul class="breadcrumb">
            <li>Extends</li>
            <li><a href="Widget.html" class="btn btn-primary">Widget</a></li>
        </ul>
    

    
    
    
        
<dt>
    <h4 class="name" id="Gadget">new Gadget<span class="signature">(<span class="optional">config</span>)</span><span class="type-signature"></span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>A gadget is the component of the applet.</p>
<h5>Usage</h5><pre class="prettyprint source"><code>var applet = new TDIApplet({
    el: $('#applet')
});
applet.render();</p><p>var gadget = new Gadget({
    tpl: &quot;&lt;h3>Preferences&lt;/h3>&lt;p>Here are your personal preferences ...&lt;/p>&quot;
    title: &quot;Preferences&quot;
}).render();</p><p>applet.add(gadget);</code></pre><h5>Events:</h5><ul>
<li>'transition:menu' - <a href="Gadget.html#menu">menu()</a></li>
<li>'transition:title' - <a href="Gadget.html#title">menu()</a></li>
<li>'transition:badge' - <a href="Gadget.html#badge">menu()</a></li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">config</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>The configuration of the gadget.</p>
<h5>Options</h5><ul>
<li>tpl(String): A html string to layout &amp; construct the DOM. Optional.</li>
<li>title(String): The title of the gadget.</li>
<li>badge(String): The badge of the gadget. Optional.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    
    <dt class="tag-since">Since:</dt>
    <dd class="tag-since"><ul class="dummy"><li>1.0</dd>
    

    
    
    
    
    
    <dt class="tag-author">Author:</dt>
    <dd class="tag-author">
        <ul>
            <li>Jason Lin</li>
        </ul>
    </dd>
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    
    
</dd>

    
    </div>
    
    
    
    
    
    
    
    
        <h3 class="subsection-title">Members</h3>
        
        <dl class="bs-docs-example bs-members">
            
<dt>
    <h4 class="name" id="_cfg"><span class="label label-info">protected</span> _cfg<span class="type-signature"> :Object</span></h4>
    
    
</dt>
<dd>
    
    <div class="description">
        <p>The initial configuration of the widget.</p>
    </div>
    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#_cfg">Widget#_cfg</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    
</dd>

        
            
<dt>
    <h4 class="name" id="tagName"><span class="label label-info">protected</span> tagName<span class="type-signature"> :String</span></h4>
    
    
</dt>
<dd>
    
    <div class="description">
        <p>The html tag name of the widget.</p>
    </div>
    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#tagName">Widget#tagName</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    
    <dt class="tag-default">Default Value:</dt>
    <dd class="tag-default"><ul class="dummy"><li>"div"</li></ul></dd>
    

    
    
    
    
    
    
    
</dl>

    
    
</dd>

        </dl>
    
    
    
        <h3 class="subsection-title">Methods</h3>
        
        <dl class="bs-docs-example bs-methods">
            
<dt>
    <h4 class="name" id="$anchor">$anchor<span class="signature">(name)</span><span class="type-signature"> &rarr; {jQuery}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>A helper method to find the specified jQuery object within the widget.</p>
<p>This method uses the data-uw-anchor attribute to locate the jQuery object.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>The name of the anchor to search for.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#$anchor">Widget#$anchor</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">jQuery</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="addClass">addClass<span class="signature">(classNames)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Add the specified class(es) to the widget.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">classNames</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>One or more space-separated classes to be added.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#addClass">Widget#addClass</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="anchor">anchor<span class="signature">(name)</span><span class="type-signature"> &rarr; {Element}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>A helper method to find the specified DOM element within the widget.</p>
<p>This method uses the data-uw-anchor attribute to locate the DOM element.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>The name of the anchor to search for.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#anchor">Widget#anchor</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Element</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="attach">attach<span class="signature">(component, <span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Attach the widget to the DOM element.</p>
<h5>Events:</h5><ul>
<li>'attach' - triggered after attach.</li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">component</td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Widget.html">Widget</a></span>
|

<span class="param-type">jQuery</span>
|

<span class="param-type">Element</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>specify the component to which this widget is attached.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.</p>
<h5>Options</h5><ul>
<li>{Boolean} prepend - Attach the widget to the begin of the element. Default: false.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#attach">Widget#attach</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="attr">attr<span class="signature">(name, <span class="optional">value</span>)</span><span class="type-signature"> &rarr; {*}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the value of an attribute.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The name of the attribute.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">value</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A value to set for the attribute.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#attr">Widget#attr</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">*</span>




<span class="param-desc">
    <p>the value of the attribute.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="badge">badge<span class="signature">(<span class="optional">text</span>, <span class="optional">options</span>)</span><span class="type-signature"> &rarr; {String}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the badge of the gadget.</p>
<h5>Events:</h5><ul>
<li>'transition:badge' =&gt; triggered after badge changed. event.data =&gt; the badge.</li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">text</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>the badge.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.</p>
<h5>Options:</h5><ul>
<li>silent(Boolean) - A false value will prevent the events from being triggered. Default: false.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">String</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="cfg">cfg<span class="signature">()</span><span class="type-signature"> &rarr; {Object}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the value of the config.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#cfg">Widget#cfg</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Object</span>




<span class="param-desc">
    <p>the config.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="css">css<span class="signature">(name, <span class="optional">value</span>)</span><span class="type-signature"> &rarr; {Object}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the value of a style property.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The css property name.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">value</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A value to set for the property.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#css">Widget#css</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Object</span>




<span class="param-desc">
    <p>css style.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="destroy">destroy<span class="signature">()</span><span class="type-signature"></span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Destroy the widget from the DOM.</p>
<p>This method removes the widget from the DOM &amp; destroy the widget.
This method also remove the event handlers registered using .listenTo().</p>
<h5>Events:</h5><ul>
<li>'destroy' - triggered before destroy.</li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#destroy">Widget#destroy</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">



<span class="param-desc">
    <p>void</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="detach">detach<span class="signature">()</span><span class="type-signature"></span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Detach the widget from the DOM.</p>
<h5>Events:</h5><ul>
<li>'detached' - triggered after detach.</li>
</ul>
<p>The method removes the widget from the DOM but keeps all data associated with the removed widget.
This method is useful when removed widget is to be reinserted into the DOM at a later time.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#detach">Widget#detach</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">



<span class="param-desc">
    <p>void</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="hasClass">hasClass<span class="signature">(name)</span><span class="type-signature"> &rarr; {Boolean}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Determine whether the widget are assigned the given class.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>The class name to search for.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#hasClass">Widget#hasClass</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Boolean</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="hide">hide<span class="signature">(<span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Hide the widget.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.
See <a href="https://api.jquery.com/hide/">jQuery.hide(options)</a> for details.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#hide">Widget#hide</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="menu">menu<span class="signature">(triggers, <span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Triggers.html">Triggers</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the menu.</p>
<h5>Events:</h5><ul>
<li>'transition:menu' =&gt; triggered after menu changed. event.data =&gt; the menu.</li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">triggers</td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Triggers.html">Triggers</a></span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>the menu.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.</p>
<h5>Options:</h5><ul>
<li>silent(Boolean) - A false value will prevent the events from being triggered. Default: false.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Triggers.html">Triggers</a></span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="prop">prop<span class="signature">(name, <span class="optional">value</span>)</span><span class="type-signature"> &rarr; {*}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the value of a property.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">name</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>The name of the property.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">value</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A value to set for the property.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#prop">Widget#prop</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">*</span>




<span class="param-desc">
    <p>The value of the property.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="query">query<span class="signature">(selector)</span><span class="type-signature"> &rarr; {NodeList}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>A helper method to find the dom elements matched the selector.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">selector</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>css selector.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#query">Widget#query</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">NodeList</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="removeClass">removeClass<span class="signature">(names)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Remove the specified class(es) from the widget.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">names</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>One or more space-separated classes to be removed.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#removeClass">Widget#removeClass</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="render"><span class="label label-info">protected</span> render<span class="signature">(<span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Render the widget.</p>
<p>This method compiles the template to generate the html, then construct the DOM element from html.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>Rendering options.</p>
                <h6>Properties</h6>
                

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		
		<th>Default</th>
		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">hidden</td>
            

            <td class="type">
            
                
<span class="param-type">Boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last"><p>A boolean value to specify the visibility after rendered.</p></td>
        </tr>

	
	</tbody>
</table>

            </td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#render">Widget#render</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="show">show<span class="signature">(<span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Display the widget.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.
See <a href="https://api.jquery.com/show/">jQuery.show(options)</a> for details.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#show">Widget#show</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="title">title<span class="signature">(<span class="optional">text</span>, <span class="optional">options</span>)</span><span class="type-signature"> &rarr; {String}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the title of the gadget.</p>
<h5>Events:</h5><ul>
<li>'transition:title' =&gt; triggered after title changed. event.data =&gt; the title.</li>
</ul>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">text</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>the title.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.</p>
<h5>Options:</h5><ul>
<li>silent(Boolean) - A false value will prevent the events from being triggered. Default: false.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">String</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="toggle">toggle<span class="signature">(<span class="optional">options</span>)</span><span class="type-signature"> &rarr; {<a href="Widget.html">Widget</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Display or hide the widget.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the method.
See <a href="https://api.jquery.com/toggle/">jQuery.toggle(options)</a> for details.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    <dd class="inherited-from"><ul class="dummy breadcrumb"><li>Inherited From:</li><li>
        <a href="Widget.html#toggle">Widget#toggle</a>
    </li></dd>
    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Widget.html">Widget</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        </dl>
    
    
    
    
    
</article>

</section>  




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:20 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>